Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.management.relation
Class RelationService

    java.lang.Object
      |
      +--javax.management.NotificationBroadcasterSupport
            |
            +--javax.management.relation.RelationService

All Implemented Interfaces:
  java.util.EventListener, MBeanRegistration, NotificationBroadcaster, NotificationEmitter, NotificationListener, RelationServiceMBean

public class RelationService
extends NotificationBroadcasterSupport
implements RelationServiceMBean, MBeanRegistration, NotificationListener

Author:
  Young Yang

Constructor Summary
`RelationService(boolean purgeFlag)`

Method Summary
`void` | `addRelation(ObjectName objectName)` add a external Relation with it's DEFAULT_OBJECTNAME
`void` | `addRelationType(RelationType relationType)` Adds given object as a relation type.
`java.lang.Integer` | `checkRoleReading(java.lang.String roleName, java.lang.String relTypeName)` Checks if given Role can be read in a relation of the given type.
`java.lang.Integer` | `checkRoleWriting(Role role, java.lang.String relTypeName, java.lang.Boolean initFlag)` Checks if given Role can be set in a relation of given type.
`void` | `createRelation(java.lang.String relationId, java.lang.String relTypeName, RoleList roleList)` doCreate a internal Relation
`void` | `createRelationType(java.lang.String relTypeName, RoleInfo[] roleInfoArray)` Creates a relation type (a RelationTypeSupport object) with given role infos (provided by the RoleInfo objects), and adds it in the Relation Service.
`java.util.Map` | `findAssociatedMBeans(ObjectName objectName, java.lang.String relTypeName, java.lang.String roleName)` Retrieves the MBeans associated to given one in a relation.
`java.util.Map` | `findReferencingRelations(ObjectName objectName, java.lang.String relTypeName, java.lang.String roleName)` Retrieves the relations where a given MBean is referenced.
`java.util.List` | `findRelationsOfType(java.lang.String relTypeName)` Returns the relation ids for relations of the given type.
`java.util.List` | `getAllRelationIds()` Returns all the relation ids for all the relations handled by the Relation Service
`java.util.List` | `getAllRelationTypeNames()` Retrieves names of all known relation types
`RoleResult` | `getAllRoles(java.lang.String relationId)` Returns all roles present in the relation
`MBeanNotificationInfo[]` | `getNotificationInfo()` Returns a NotificationInfo object contaning the name of the Java class of the notification and the notification types sent.
`boolean` | `getPurgeFlag()` Returns the flag to indicate if when a notification is received for the unregistration of a MBean referenced in a relation, if an immediate "purge" of the relations (look for the relations no longer valid) has to be performed , or if that will be performed only when the purgeRelations method will be explicitly called.
`java.util.Map` | `getReferencedMBeans(java.lang.String relationId)` Retrieves MBeans referenced in the various roles of the relation.
`java.lang.String` | `getRelationTypeName(java.lang.String relationId)` Returns name of associated relation type for given relation.
`java.util.List` | `getRole(java.lang.String relationId, java.lang.String roleName)` Retrieves role value for given role name in given relation.
`java.lang.Integer` | `getRoleCardinality(java.lang.String relationId, java.lang.String roleName)` Retrieves the number of MBeans currently referenced in the given role
`RoleInfo` | `getRoleInfo(java.lang.String relTypeName, java.lang.String roleInfoName)` Retrieves role info for given role of a given relation type
`java.util.List` | `getRoleInfos(java.lang.String relTypeName)` Retrieves list of role infos (RoleInfo objects) of a given relation type
`RoleResult` | `getRoles(java.lang.String relationId, java.lang.String[] roleNames)` Retrieves values of roles with given names in given relation.
`void` | `handleNotification(Notification notif, java.lang.Object handback)` Invoked when a JMX notification occurs.
`java.lang.Boolean` | `hasRelation(java.lang.String relationId)` Checks if there is a relation identified in Relation Service with given relation id.
`void` | `isActive()` Checks if the Relation Service is active.
`java.lang.String` | `isRelation(ObjectName objectName)` return relation id (String) or null (if the ObjectName is not a relation handled by the Relation Service)
`ObjectName` | `isRelationMBean(java.lang.String relationId)` If the relation is represented by a MBean (created by the user and added as a relation in the Relation Service), returns the ObjectName of the MBean.
`void` | `postDeregister()` Allows the MBean to perform any operations needed after having been de-registered in the MBean server.
`void` | `postRegister(java.lang.Boolean registrationDone)` Allows the MBean to perform any operations needed after having been registered in the MBean server or after the registration has failed.
`void` | `preDeregister()` Allows the MBean to perform any operations it needs before being de-registered by the MBean server.
`ObjectName` | `preRegister(MBeanServer server, ObjectName name)` Allows the MBean to perform any operations it needs before being registered in the MBean server.
`void` | `purgeRelations()` Purges the relations.
`void` | `removeRelation(java.lang.String relationId)` Removes given relation from the Relation Service.
`void` | `removeRelationType(java.lang.String relTypeName)` Removes given relation type from Relation Service.
`void` | `sendRelationCreationNotification(java.lang.String relationId)` Sends a notification (RelationNotification) for a relation creation.
`void` | `sendRelationRemovalNotification(java.lang.String relationId, java.util.List unregMBeanList)` Sends a notification (RelationNotification) for a relation removal.
`void` | `sendRoleUpdateNotification(java.lang.String relationId, Role newRole, java.util.List oldRoleValue)` Sends a notification (RelationNotification) for a role update in the given relation.
`void` | `setPurgeFlag(boolean flag)` Sets the flag to indicate if when a notification is received for the unregistration of a MBean referenced in a relation, if an immediate "purge" of the relations (look for the relations no longer valid) has to be performed , or if that will be performed only when the purgeRelations method will be explicitly called.
`void` | `setRole(java.lang.String relationId, Role role)` Sets the given role in given relation.
`RoleResult` | `setRoles(java.lang.String relationId, RoleList roleList)` Sets the given roles in given relation.
`void` | `updateRoleMap(java.lang.String relationId, Role role, java.util.List oldRoleValue)` Handles update of the Relation Service role map for the update of given role in given relation.

Methods inherited from class javax.management.NotificationBroadcasterSupport
`addNotificationListener, handleNotification, removeNotificationListener, removeNotificationListener, sendNotification`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### RelationService

    public RelationService(boolean purgeFlag)

Method Detail

### setPurgeFlag

    public void setPurgeFlag(boolean flag)

  Sets the flag to indicate if when a notification is received for the unregistration of a MBean referenced in a relation, if an immediate "purge" of the relations (look for the relations no longer valid) has to be performed , or if that will be performed only when the purgeRelations method will be explicitly called.

  true is immediate purge.

  Specified by:
    `setPurgeFlag` in interface `RelationServiceMBean`
  Parameters:
    `flag` - flag

### getPurgeFlag

    public boolean getPurgeFlag()

  Description copied from interface: `RelationServiceMBean`
  Returns the flag to indicate if when a notification is received for the unregistration of a MBean referenced in a relation, if an immediate "purge" of the relations (look for the relations no longer valid) has to be performed , or if that will be performed only when the purgeRelations method will be explicitly called.

  true is immediate purge.

  Specified by:
    `getPurgeFlag` in interface `RelationServiceMBean`

### isActive

    public void isActive()
                  throws RelationServiceNotRegisteredException

  Description copied from interface: `RelationServiceMBean`
  Checks if the Relation Service is active. Current condition is that the Relation Service must be registered in the MBean Server
  Specified by:
    `isActive` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Throws:
    `RelationServiceNotRegisteredException` - if it is not registered

### createRelationType

    public void createRelationType(java.lang.String relTypeName,
                                   RoleInfo[] roleInfoArray)
                            throws java.lang.IllegalArgumentException,
                                   InvalidRelationTypeException

  Creates a relation type (a RelationTypeSupport object) with given role infos (provided by the RoleInfo objects), and adds it in the Relation Service.
  Specified by:
    `createRelationType` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relTypeName` - name of the relation type
    `roleInfoArray` - array of role infos
  Throws:
    `java.lang.IllegalArgumentException` - if null parameter
    `InvalidRelationTypeException` - If:

    - there is already a relation type with that name

    - the same name has been used for two different role infos

    - no role info provided

    - one null role info provided

### addRelationType

    public void addRelationType(RelationType relationType)
                         throws java.lang.IllegalArgumentException,
                                InvalidRelationTypeException

  Adds given object as a relation type. The object is expected to implement the relationType interface.
  Specified by:
    `addRelationType` in interface `RelationServiceMBean`
  Parameters:
    `relationType` - relation type object (implementing the relationType interface)

### createRelation

    public void createRelation(java.lang.String relationId,
                               java.lang.String relTypeName,
                               RoleList roleList)
                        throws RelationServiceNotRegisteredException,
                               java.lang.IllegalArgumentException,
                               RoleNotFoundException,
                               InvalidRelationIdException,
                               RelationTypeNotFoundException,
                               InvalidRoleValueException

  doCreate a internal Relation
  Specified by:
    `createRelation` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relationId` - relation identifier, to uniquely identify the relation inside the Relation Service
    `relTypeName` - name of the relation type (has to be created in the Relation Service)
    `roleList` - role list to initialise roles of the relation (can be null).
  Throws:
    `RelationServiceNotRegisteredException` - if the Relation Service is not registered in the MBean Server
    `java.lang.IllegalArgumentException` - if null paramater
    `RoleNotFoundException` - if a value is provided for a role that does not exist in the relation type
    `InvalidRelationIdException` - if relation id already used
    `RelationTypeNotFoundException` - if relation type not known in Relation Service
    `InvalidRoleValueException` - if:

    - the same role name is used for two different roles

    - the number of referenced MBeans in given value is less than expected minimum degree

    - the number of referenced MBeans in provided value exceeds expected maximum degree

    - one referenced MBean in the value is not an Object of the MBean class expected for that role

    - a MBean provided for that role does not exist

### addRelation

    public void addRelation(ObjectName objectName)
                     throws java.lang.IllegalArgumentException,
                            RelationServiceNotRegisteredException,
                            java.lang.NoSuchMethodException,
                            InvalidRelationIdException,
                            InstanceNotFoundException,
                            InvalidRelationServiceException,
                            RelationTypeNotFoundException,
                            RoleNotFoundException,
                            InvalidRoleValueException

  add a external Relation with it's DEFAULT_OBJECTNAME
  Specified by:
    `addRelation` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `objectName` - ObjectName of the relation MBean to be added.
  Throws:
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationServiceNotRegisteredException` - if the Relation Service is not registered in the MBean Server
    `java.lang.NoSuchMethodException` - If the MBean does not implement the Relation interface
    `InvalidRelationIdException` - if:

    - no relation identifier in MBean

    - the relation identifier is already used in the Relation Service

    `InstanceNotFoundException` - if the MBean for given ObjectName has not been registered
    `InvalidRelationServiceException` - if:

    - no Relation Service name in MBean

    - the Relation Service name in the MBean is not the one of the current Relation Service

    `RelationTypeNotFoundException` - if:

    - no relation type name in MBean

    - the relation type name in MBean does not correspond to a relation type created in the Relation Service

    `InvalidRoleValueException` - if:

    - the number of referenced MBeans in a role is less than expected minimum degree

    - the number of referenced MBeans in a role exceeds expected maximum degree

    - one referenced MBean in the value is not an Object of the MBean class expected for that role

    - a MBean provided for a role does not exist

    `RoleNotFoundException` - if a value is provided for a role that does not exist in the relation type

### getAllRelationTypeNames

    public java.util.List getAllRelationTypeNames()

  Retrieves names of all known relation types
  Specified by:
    `getAllRelationTypeNames` in interface `RelationServiceMBean`
  Returns:
    ArrayList of relation type names (Strings)

### getAllRelationIds

    public java.util.List getAllRelationIds()

  Description copied from interface: `RelationServiceMBean`
  Returns all the relation ids for all the relations handled by the Relation Service
  Specified by:
    `getAllRelationIds` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Returns:
    ArrayList of String

### getRoleInfos

    public java.util.List getRoleInfos(java.lang.String relTypeName)
                                throws java.lang.IllegalArgumentException,
                                       RelationTypeNotFoundException

  Retrieves list of role infos (RoleInfo objects) of a given relation type
  Specified by:
    `getRoleInfos` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relTypeName` - name of relation type
  Returns:
    ArrayList of RoleInfo.
  Throws:
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationTypeNotFoundException` - if there is no relation type with that name.

### getRoleInfo

    public RoleInfo getRoleInfo(java.lang.String relTypeName,
                                java.lang.String roleInfoName)
                         throws java.lang.IllegalArgumentException,
                                RelationTypeNotFoundException,
                                RoleInfoNotFoundException

  Description copied from interface: `RelationServiceMBean`
  Retrieves role info for given role of a given relation type
  Specified by:
    `getRoleInfo` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relTypeName` - name of relation type
    `roleInfoName` - name of role
  Returns:
    RoleInfo object.
  Throws:
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationTypeNotFoundException` - if the relation type is not known in the Relation Service
    `RoleInfoNotFoundException` - if the role is not part of the relation type.

### getAllRoles

    public RoleResult getAllRoles(java.lang.String relationId)
                           throws java.lang.IllegalArgumentException,
                                  RelationNotFoundException,
                                  RelationServiceNotRegisteredException

  Description copied from interface: `RelationServiceMBean`
  Returns all roles present in the relation
  Specified by:
    `getAllRoles` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relationId` - relation id
  Returns:
    a RoleResult object, including a RoleList (for roles succcessfully retrieved) and a RoleUnresolvedList (for roles not readable).
  Throws:
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationNotFoundException` - if no relation for given id
    `RelationServiceNotRegisteredException` - if the Relation Service is not registered in the MBean Server

### getRole

    public java.util.List getRole(java.lang.String relationId,
                                  java.lang.String roleName)
                           throws RelationServiceNotRegisteredException,
                                  java.lang.IllegalArgumentException,
                                  RelationNotFoundException,
                                  RoleNotFoundException

  Description copied from interface: `RelationServiceMBean`
  Retrieves role value for given role name in given relation.
  Specified by:
    `getRole` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relationId` - relation id
    `roleName` - name of role
  Returns:
    the ArrayList of ObjectName objects being the role value
  Throws:
    `RelationServiceNotRegisteredException` - if the Relation Service is not registered
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationNotFoundException` - if no relation with given id
    `RoleNotFoundException` - if:

    - there is no role with given name

    or

    - the role is not readable.

### getRoleCardinality

    public java.lang.Integer getRoleCardinality(java.lang.String relationId,
                                                java.lang.String roleName)
                                         throws java.lang.IllegalArgumentException,
                                                RelationNotFoundException,
                                                RoleNotFoundException

  Description copied from interface: `RelationServiceMBean`
  Retrieves the number of MBeans currently referenced in the given role
  Specified by:
    `getRoleCardinality` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relationId` - relation id
    `roleName` - name of role
  Returns:
    the number of currently referenced MBeans in that role
  Throws:
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationNotFoundException` - if no relation with given id
    `RoleNotFoundException` - if there is no role with given name

### getRoles

    public RoleResult getRoles(java.lang.String relationId,
                               java.lang.String[] roleNames)
                        throws RelationServiceNotRegisteredException,
                               java.lang.IllegalArgumentException,
                               RelationNotFoundException

  Description copied from interface: `RelationServiceMBean`
  Retrieves values of roles with given names in given relation.
  Specified by:
    `getRoles` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relationId` - relation id
    `roleNames` - array of names of roles to be retrieved
  Returns:
    a RoleResult object, including a RoleList (for roles succcessfully retrieved) and a RoleUnresolvedList (for roles not retrieved).
  Throws:
    `RelationServiceNotRegisteredException` - if the Relation Service is not registered in the MBean Server
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationNotFoundException` - if no relation with given id

### findRelationsOfType

    public java.util.List findRelationsOfType(java.lang.String relTypeName)
                                       throws java.lang.IllegalArgumentException,
                                              RelationTypeNotFoundException

  Description copied from interface: `RelationServiceMBean`
  Returns the relation ids for relations of the given type.
  Specified by:
    `findRelationsOfType` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relTypeName` - relation type name
  Returns:
    an ArrayList of relation ids.
  Throws:
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationTypeNotFoundException` - if there is no relation type with that name.

### findReferencingRelations

    public java.util.Map findReferencingRelations(ObjectName objectName,
                                                  java.lang.String relTypeName,
                                                  java.lang.String roleName)
                                           throws java.lang.IllegalArgumentException

  Retrieves the relations where a given MBean is referenced.
  Specified by:
    `findReferencingRelations` in interface `RelationServiceMBean`
  Parameters:
    `objectName` - ObjectName of MBean
    `relTypeName` - can be null; if specified, only the relations of that type will be considered in the search. Else all relation types are considered.
    `roleName` - can be null; if specified, only the relations where the MBean is referenced in that role will be returned. Else all roles are considered.
  Returns:
    an HashMap, where the keys are the relation ids of the relations where the MBean is referenced, and the value is, for each key, an ArrayList of role names (as a MBean can be referenced in several roles in the same relation).

### findAssociatedMBeans

    public java.util.Map findAssociatedMBeans(ObjectName objectName,
                                              java.lang.String relTypeName,
                                              java.lang.String roleName)
                                       throws java.lang.IllegalArgumentException

  Retrieves the MBeans associated to given one in a relation.

  This corresponds to CIM Associators and AssociatorNames operations.

  Specified by:
    `findAssociatedMBeans` in interface `RelationServiceMBean`
  Parameters:
    `objectName` - ObjectName of MBean
    `relTypeName` - can be null; if specified, only the relations of that type will be considered in the search. Else all relation types are considered.
    `roleName` - can be null; if specified, only the relations where the MBean is referenced in that role will be considered. Else all roles are considered.
  Returns:
    an HashMap, where the keys are the ObjectNames of the MBeans associated to given MBean, and the value is, for each key, an ArrayList of the relation ids of the relations where the key MBean is associated to given one (as they can be associated in several different relations).
  Throws:
    `java.lang.IllegalArgumentException` - if null parameter

### getReferencedMBeans

    public java.util.Map getReferencedMBeans(java.lang.String relationId)
                                      throws java.lang.IllegalArgumentException,
                                             RelationNotFoundException

  Retrieves MBeans referenced in the various roles of the relation.
  Specified by:
    `getReferencedMBeans` in interface `RelationServiceMBean`
  Parameters:
    `relationId` - relation id
  Returns:
    a HashMap mapping:

    ObjectName -> ArrayList of String (role names)

### getRelationTypeName

    public java.lang.String getRelationTypeName(java.lang.String relationId)
                                         throws java.lang.IllegalArgumentException,
                                                RelationNotFoundException

  Description copied from interface: `RelationServiceMBean`
  Returns name of associated relation type for given relation.
  Specified by:
    `getRelationTypeName` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relationId` - relation id
  Throws:
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationNotFoundException` - if no relation for given relation id

### hasRelation

    public java.lang.Boolean hasRelation(java.lang.String relationId)
                                  throws java.lang.IllegalArgumentException

  Description copied from interface: `RelationServiceMBean`
  Checks if there is a relation identified in Relation Service with given relation id.
  Specified by:
    `hasRelation` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relationId` - relation id identifying the relation
  Returns:
    boolean: true if there is a relation, false else
  Throws:
    `java.lang.IllegalArgumentException` - if null parameter

### isRelation

    public java.lang.String isRelation(ObjectName objectName)
                                throws java.lang.IllegalArgumentException

  return relation id (String) or null (if the ObjectName is not a relation handled by the Relation Service)
  Specified by:
    `isRelation` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `objectName` - ObjectName of supposed relation
  Returns:
    relation id (String) or null (if the ObjectName is not a relation handled by the Relation Service)
  Throws:
    `java.lang.IllegalArgumentException` - if null parameter

### isRelationMBean

    public ObjectName isRelationMBean(java.lang.String relationId)
                               throws java.lang.IllegalArgumentException,
                                      RelationNotFoundException

  If the relation is represented by a MBean (created by the user and added as a relation in the Relation Service), returns the ObjectName of the MBean.
  Specified by:
    `isRelationMBean` in interface `RelationServiceMBean`
  Returns:
    ObjectName of the corresponding relation MBean, or null if the relation is not a MBean.

### checkRoleReading

    public java.lang.Integer checkRoleReading(java.lang.String roleName,
                                              java.lang.String relTypeName)
                                       throws java.lang.IllegalArgumentException,
                                              RelationTypeNotFoundException

  Description copied from interface: `RelationServiceMBean`
  Checks if given Role can be read in a relation of the given type.
  Specified by:
    `checkRoleReading` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `roleName` - name of role to be checked
    `relaionTypeName` - name of the relation type
  Returns:
    an Integer wrapping an integer corresponding to possible problems represented as constants in RoleUnresolved:

    - 0 if role can be read

    - integer corresponding to RoleStatus.NO_ROLE_WITH_NAME

    - integer corresponding to RoleStatus.ROLE_NOT_READABLE

  Throws:
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationTypeNotFoundException` - if the relation type is not known in the Relation Service

### checkRoleWriting

    public java.lang.Integer checkRoleWriting(Role role,
                                              java.lang.String relTypeName,
                                              java.lang.Boolean initFlag)
                                       throws java.lang.IllegalArgumentException,
                                              RelationTypeNotFoundException

  Description copied from interface: `RelationServiceMBean`
  Checks if given Role can be set in a relation of given type.
  Specified by:
    `checkRoleWriting` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `role` - role to be checked
    `relTypeName` - name of relation type
    `initFlag` - flag to specify that the checking is done for the initialisation of a role, write access shall not be verified.
  Returns:
    an Integer wrapping an integer corresponding to possible problems represented as constants in RoleUnresolved:

    - 0 if role can be set

    - integer corresponding to RoleStatus.NO_ROLE_WITH_NAME

    - integer for RoleStatus.ROLE_NOT_WRITABLE

    - integer for RoleStatus.LESS_THAN_MIN_ROLE_DEGREE

    - integer for RoleStatus.MORE_THAN_MAX_ROLE_DEGREE

    - integer for RoleStatus.REF_MBEAN_OF_INCORRECT_CLASS

    - integer for RoleStatus.REF_MBEAN_NOT_REGISTERED

  Throws:
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationTypeNotFoundException` - if unknown relation type

### handleNotification

    public void handleNotification(Notification notif,
                                   java.lang.Object handback)

  Invoked when a JMX notification occurs. Currently handles notifications for unregistration of MBeans, either referenced in a relation role or being a relation itself.
  Specified by:
    `handleNotification` in interface `NotificationListener`
  Parameters:
    `notif` - The notification.
    `handback` - An opaque object which helps the listener to associate information regarding the MBean emitter (can be null).

### removeRelationType

    public void removeRelationType(java.lang.String relTypeName)
                            throws RelationServiceNotRegisteredException,
                                   java.lang.IllegalArgumentException,
                                   RelationTypeNotFoundException

  Description copied from interface: `RelationServiceMBean`
  Removes given relation type from Relation Service.

  The relation objects of that type will be removed from the Relation Service.

  Specified by:
    `removeRelationType` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relTypeName` - name of the relation type to be removed
  Throws:
    `RelationServiceNotRegisteredException` - if the Relation Service is not registered in the MBean Server
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationTypeNotFoundException` - If there is no relation type with that name

### setRole

    public void setRole(java.lang.String relationId,
                        Role role)
                 throws RelationServiceNotRegisteredException,
                        java.lang.IllegalArgumentException,
                        RelationNotFoundException,
                        RoleNotFoundException,
                        InvalidRoleValueException

  Description copied from interface: `RelationServiceMBean`
  Sets the given role in given relation.

  Will check the role according to its corresponding role definition provided in relation's relation type

  The Relation Service will keep track of the change to keep the consistency of relations by handling referenced MBean unregistrations.

  Specified by:
    `setRole` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relationId` - relation id
    `role` - role to be set (name and new value)
  Throws:
    `RelationServiceNotRegisteredException` - if the Relation Service is not registered in the MBean Server
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationNotFoundException` - if no relation with given id
    `RoleNotFoundException` - if:

    - internal relation

    and

    - the role does not exist or is not writable

    `InvalidRoleValueException` - if internal relation and value provided for role is not valid:

    - the number of referenced MBeans in given value is less than expected minimum degree

    or

    - the number of referenced MBeans in provided value exceeds expected maximum degree

    or

    - one referenced MBean in the value is not an Object of the MBean class expected for that role

    or

    - a MBean provided for that role does not exist

    `RelationTypeNotFoundException` - if unknown relation type

### setRoles

    public RoleResult setRoles(java.lang.String relationId,
                               RoleList roleList)
                        throws RelationServiceNotRegisteredException,
                               java.lang.IllegalArgumentException,
                               RelationNotFoundException

  Description copied from interface: `RelationServiceMBean`
  Sets the given roles in given relation.

  Will check the role according to its corresponding role definition provided in relation's relation type

  The Relation Service keeps track of the changes to keep the consistency of relations by handling referenced MBean unregistrations.

  Specified by:
    `setRoles` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relationId` - relation id
    `roleList` - list of roles to be set
  Returns:
    a RoleResult object, including a RoleList (for roles succcessfully set) and a RoleUnresolvedList (for roles not set).
  Throws:
    `RelationServiceNotRegisteredException` - if the Relation Service is not registered in the MBean Server
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationNotFoundException` - if no relation with given id

### updateRoleMap

    public void updateRoleMap(java.lang.String relationId,
                              Role role,
                              java.util.List oldRoleValue)
                       throws java.lang.IllegalArgumentException,
                              RelationServiceNotRegisteredException,
                              RelationNotFoundException

  Description copied from interface: `RelationServiceMBean`
  Handles update of the Relation Service role map for the update of given role in given relation.

  It is called in relation MBean setRole() (for given role) and setRoles() (for each role) methods (implementation provided in RelationSupport class).

  It is also called in Relation Service setRole() (for given role) and setRoles() (for each role) methods.

  To allow the Relation Service to maintain the consistency (in case of MBean unregistration) and to be able to perform queries, this method must be called when a role is updated.

  Specified by:
    `updateRoleMap` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relationId` - relation identifier of the updated relation
    `role` - new role (name and new value)
    `oldRoleValue` - old role value (ArrayList of ObjectName objects)
  Throws:
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationServiceNotRegisteredException` - if the Relation Service is not registered in the MBean Server
    `RelationNotFoundException` - if no relation for given id.

### purgeRelations

    public void purgeRelations()
                        throws RelationServiceNotRegisteredException

  Description copied from interface: `RelationServiceMBean`
  Purges the relations.

  Depending on the purgeFlag value, this method is either called automatically when a notification is received for the unregistration of a MBean referenced in a relation (if the flag is set to true), or not (if the flag is set to false).

  In that case it is up to the user to call it to maintain the consistency of the relations. To be kept in mind that if a MBean is unregistered and the purge not done immediately, if the ObjectName is reused and assigned to another MBean referenced in a relation, calling manually this purgeRelations() method will cause trouble, as will consider the ObjectName as corresponding to the unregistered MBean, not seeing the new one.

  The behavior depends on the cardinality of the role where the unregistered MBean is referenced:

  - if removing one MBean reference in the role makes its number of references less than the minimum degree, the relation has to be removed.

  - if the remaining number of references after removing the MBean reference is still in the cardinality range, keep the relation and update it calling its handleMBeanUnregistration() callback.

  Specified by:
    `purgeRelations` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Throws:
    `RelationServiceNotRegisteredException` - if the Relation Service is not registered in the MBean Server.

### removeRelation

    public void removeRelation(java.lang.String relationId)
                        throws RelationServiceNotRegisteredException,
                               java.lang.IllegalArgumentException,
                               RelationNotFoundException

  Description copied from interface: `RelationServiceMBean`
  Removes given relation from the Relation Service.

  A RelationNotification notification is sent, its type being:

  - RelationNotification.RELATION_BASIC_REMOVAL if the relation was only internal to the Relation Service

  - RelationNotification.RELATION_MBEAN_REMOVAL if the relation is registered as a MBean.

  For MBeans referenced in such relation, nothing will be done,

  Specified by:
    `removeRelation` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relationId` - relation id of the relation to be removed
  Throws:
    `RelationServiceNotRegisteredException` - if the Relation Service is not registered in the MBean Server
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationNotFoundException` - if no relation corresponding to given relation id

### sendRelationCreationNotification

    public void sendRelationCreationNotification(java.lang.String relationId)
                                          throws java.lang.IllegalArgumentException,
                                                 RelationNotFoundException

  Description copied from interface: `RelationServiceMBean`
  Sends a notification (RelationNotification) for a relation creation. The notification type is:

  - RelationNotification.RELATION_BASIC_CREATION if the relation is an object internal to the Relation Service

  - RelationNotification.RELATION_MBEAN_CREATION if the relation is a MBean added as a relation.

  The source object is the Relation Service itself.

  It is called in Relation Service createRelation() and addRelation() methods.

  Specified by:
    `sendRelationCreationNotification` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relationId` - relation identifier of the updated relation
  Throws:
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationNotFoundException` - if there is no relation for given relation id

### sendRelationRemovalNotification

    public void sendRelationRemovalNotification(java.lang.String relationId,
                                                java.util.List unregMBeanList)
                                         throws java.lang.IllegalArgumentException,
                                                RelationNotFoundException

  Description copied from interface: `RelationServiceMBean`
  Sends a notification (RelationNotification) for a relation removal. The notification type is:

  - RelationNotification.RELATION_BASIC_REMOVAL if the relation is an object internal to the Relation Service

  - RelationNotification.RELATION_MBEAN_REMOVAL if the relation is a MBean added as a relation.

  The source object is the Relation Service itself.

  It is called in Relation Service removeRelation() method.

  Specified by:
    `sendRelationRemovalNotification` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relaionId` - relation identifier of the updated relation
    `unregMBeanList` - ArrayList of ObjectNames of MBeans expected to be unregistered due to relation removal (can be null)
  Throws:
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationNotFoundException` - if there is no relation for given relation id

### sendRoleUpdateNotification

    public void sendRoleUpdateNotification(java.lang.String relationId,
                                           Role newRole,
                                           java.util.List oldRoleValue)
                                    throws java.lang.IllegalArgumentException,
                                           RelationNotFoundException

  Description copied from interface: `RelationServiceMBean`
  Sends a notification (RelationNotification) for a role update in the given relation. The notification type is:

  - RelationNotification.RELATION_BASIC_UPDATE if the relation is an object internal to the Relation Service

  - RelationNotification.RELATION_MBEAN_UPDATE if the relation is a MBean added as a relation.

  The source object is the Relation Service itself.

  It is called in relation MBean setRole() (for given role) and setRoles() (for each role) methods (implementation provided in RelationSupport class).

  It is also called in Relation Service setRole() (for given role) and setRoles() (for each role) methods.

  Specified by:
    `sendRoleUpdateNotification` in interface `RelationServiceMBean`
  Following copied from interface: `javax.management.relation.RelationServiceMBean`
  Parameters:
    `relationId` - relation identifier of the updated relation
    `newRole` - new role (name and new value)
    `oldRoleValue` - old role value (ArrayList of ObjectName objects)
  Throws:
    `java.lang.IllegalArgumentException` - if null parameter
    `RelationNotFoundException` - if there is no relation for given relation id

### getNotificationInfo

    public MBeanNotificationInfo[] getNotificationInfo()

  Description copied from class: `NotificationBroadcasterSupport`
  Returns a NotificationInfo object contaning the name of the Java class of the notification and the notification types sent.
  Overrides:
    `getNotificationInfo` in class `NotificationBroadcasterSupport`

### preRegister

    public ObjectName preRegister(MBeanServer server,
                                  ObjectName name)
                           throws java.lang.Exception

  Description copied from interface: `MBeanRegistration`
  Allows the MBean to perform any operations it needs before being registered in the MBean server. If the name of the MBean is not specified, the MBean can provide a name for its registration. If any exception is raised, the MBean will not be registered in the MBean server.
  Specified by:
    `preRegister` in interface `MBeanRegistration`
  Following copied from interface: `javax.management.MBeanRegistration`
  Parameters:
    `server` - The MBean server in which the MBean will be registered.
    `name` - The object name of the MBean.
  Returns:
    The name of the MBean registered.
  Throws:
    `java.lang.Exception` - This exception should be caught by the MBean server and re-thrown as an `MBeanRegistrationException`.

### postRegister

    public void postRegister(java.lang.Boolean registrationDone)

  Description copied from interface: `MBeanRegistration`
  Allows the MBean to perform any operations needed after having been registered in the MBean server or after the registration has failed.
  Specified by:
    `postRegister` in interface `MBeanRegistration`
  Following copied from interface: `javax.management.MBeanRegistration`
  Parameters:
    `registrationDone` - Indicates whether or not the MBean has been successfully registered in the MBean server. The value false means that the registration phase has failed.

### preDeregister

    public void preDeregister()
                       throws java.lang.Exception

  Description copied from interface: `MBeanRegistration`
  Allows the MBean to perform any operations it needs before being de-registered by the MBean server.
  Specified by:
    `preDeregister` in interface `MBeanRegistration`
  Following copied from interface: `javax.management.MBeanRegistration`
  Throws:
    `java.lang.Exception` - This exception should be caught by the MBean server and re-thrown as an `MBeanRegistrationException`.

### postDeregister

    public void postDeregister()

  Description copied from interface: `MBeanRegistration`
  Allows the MBean to perform any operations needed after having been de-registered in the MBean server.
  Specified by:
    `postDeregister` in interface `MBeanRegistration`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD